//+------------------------------------------------------------------+
//|                                            best div original.mq4 |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Navy//C'255,255,255'//DarkGray
#property indicator_color4 CLR_NONE//C'255,255,255'//DarkBlue
#property indicator_color5 CLR_NONE
#property indicator_color6 CLR_NONE
//----
#define arrowsDisplacement 0.0001
//---- input parameters
extern string separator1 = "*** CCI-OnArray Settings ***";
extern int MA=8;
extern int mode =3;
extern int price=5;
extern int CCI=21;
extern string separator2 = "*** Indicator Settings ***";
extern bool   drawIndicatorTrendLines = false;
extern bool   drawPriceTrendLines = false;
extern bool   displayAlert = true;
//---- buffers
double bullishDivergence[];
double bearishDivergence[];
double     Buf1[];
double     Buf2[];
//double cci[];
//double signal[];
double priceh[];
double pricel[];
double previoushighbuffer[];
double previouslowbuffer[];
//---- indicator buffers
//double     Buf0[];
//----
static datetime lastAlertTime;
static string   indicatorName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexStyle(3, DRAW_NONE);
   SetIndexBuffer(4, DRAW_NONE);
   SetIndexBuffer(5, DRAW_NONE);
   SetIndexBuffer(6, DRAW_NONE);
   SetIndexBuffer(7, DRAW_NONE);
   
   SetIndexBuffer(0, bullishDivergence);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexBuffer(1, bearishDivergence);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexBuffer(2, Buf1);
   SetIndexBuffer(3, Buf2);
   SetIndexBuffer(4, priceh);
   SetIndexBuffer(5, pricel); 
   SetIndexBuffer(6, previoushighbuffer);
   SetIndexBuffer(7, previouslowbuffer);  
//----   
   SetIndexArrow(0, 233);
   SetIndexArrow(1, 234);
//----
   indicatorName = "best div original";
   IndicatorDigits(Digits + 2);
   IndicatorShortName(indicatorName);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int countedBars = IndicatorCounted();
   if(countedBars < 0)
       countedBars = 0;
   int limit,i;
//---- last counted bar will be recounted
   //if(counted_bars>0) counted_bars--;
   limit=Bars-countedBars;
//---- MA counted in the last buffer
   for(i=limit; i>=0; i--) 
      Buf2[i]=iMA(NULL,0,MA,0,mode,price,i);
//---- CCI counted in the free buffer
   for(i=limit; i>=0; i--){
      //Buf0[i]=iCCIOnArray(Buf2,Bars,CCI,i);
      Buf1[i]=iCCIOnArray(Buf2,Bars,CCI,i);
      //cci[i]=Buf1[i];
     }    
   CalculateIndicator(countedBars);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalculateIndicator(int countedBars)
  {
   for(int i = Bars - countedBars; i >= 0; i--)
     {
       //Calculatecci(i);
       Calculateprice(i);
       CatchBullishDivergence(i + 2);
       CatchBearishDivergence(i + 2);
     }              
  }

//+------------------------------------------------------------------+
void Calculateprice(int i)
  {
   priceh[i]=High[i];//iHighest(NULL, 0,MODE_HIGH,2, i)]; 
   pricel[i]=Low[i];//iLowest(NULL,0,MODE_LOW,2,i)];     
  }
//+------------------------------------------------------------------+
void CatchBullishDivergence(int shift)
  {
   if(IsIndicatorTrough(shift) == false)
       return;  
   int currentTrough = shift; 
   int low=GetIndicatorLastTrough(shift,low);
   int lastTrough = GetIndicatorLastTrough(shift,low);
   
//----   
   if(
      //pricel[currentTrough] <= pricel[currentTrough+1]&&
      (
     (Buf1[currentTrough] > Buf1[lastTrough]) ||
     (Buf1[currentTrough] > Buf1[low+2])||
     (Buf1[currentTrough] > Buf1[low+3])||
     (Buf1[currentTrough] > Buf1[low+4])||
     (Buf1[currentTrough] > Buf1[low+5])||
     (Buf1[currentTrough] > Buf1[low+6])||
     (Buf1[currentTrough] > Buf1[low+7])||
     (Buf1[currentTrough] > Buf1[low+8])||
     (Buf1[currentTrough] > Buf1[low+9])||
     (Buf1[currentTrough] > Buf1[low+10])
     //(cci[currentTrough] > cci[low+11])||
     //(cci[currentTrough] > cci[low+12])||
     //(cci[currentTrough] > cci[low+13])||
     //(cci[currentTrough] > cci[low+14])||
     //(cci[currentTrough] > cci[low+15])
       )
      &&
      (
      (pricel[currentTrough] < pricel[lastTrough])||
      (pricel[currentTrough] < pricel[low+2])||
      (pricel[currentTrough] < pricel[low+3])||
      (pricel[currentTrough] < pricel[low+4])||
      (pricel[currentTrough] < pricel[low+5]) ||
      (pricel[currentTrough] < pricel[low+6])  ||
      (pricel[currentTrough] < pricel[low+7])||
      (pricel[currentTrough] < pricel[low+8])||
      (pricel[currentTrough] < pricel[low+9])||
      (pricel[currentTrough] < pricel[low+10])||
      (pricel[currentTrough] < pricel[low+11])||
      (pricel[currentTrough] < pricel[low+12])||
      (pricel[currentTrough] < pricel[low+13])||
      (pricel[currentTrough] < pricel[low+14])||
      (pricel[currentTrough] < pricel[low+15])     
      )
      )      
      {
       bullishDivergence[currentTrough] = Buf1[currentTrough] - 
                                          arrowsDisplacement;
       //----
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentTrough], Time[lastTrough], 
                              pricel[currentTrough], 
                             pricel[lastTrough], Green, STYLE_SOLID);
       //----
       if(drawIndicatorTrendLines == true)
          DrawIndicatorTrendLine(Time[currentTrough], 
                                 Time[lastTrough], 
                                 Buf1[currentTrough],
                                 Buf1[lastTrough], 
                                 Green, STYLE_SOLID);
       //----
       if(displayAlert == true)
          DisplayAlert("  ", currentTrough);  
     }
//----
 if(
      //pricel[currentTrough] <= pricel[currentTrough+1]&&
      (
     (Buf1[currentTrough] < Buf1[lastTrough]) ||
     (Buf1[currentTrough] < Buf1[low+2])||
     (Buf1[currentTrough] < Buf1[low+3])||
     (Buf1[currentTrough] < Buf1[low+4])||
     (Buf1[currentTrough] < Buf1[low+5])||
     (Buf1[currentTrough] < Buf1[low+6])||
     (Buf1[currentTrough] < Buf1[low+7])||
     (Buf1[currentTrough] < Buf1[low+8])||
     (Buf1[currentTrough] < Buf1[low+9])||
     (Buf1[currentTrough] < Buf1[low+10])
     //(cci[currentTrough] < cci[low+11])||
     //(cci[currentTrough] < cci[low+12])||
     //(cci[currentTrough] < cci[low+13])||
     //(cci[currentTrough] < cci[low+14])||
     //(cci[currentTrough] < cci[low+15])
       )
      &&
      (
      (pricel[currentTrough] > pricel[lastTrough])||
      (pricel[currentTrough] > pricel[low+2])||
      (pricel[currentTrough] > pricel[low+3])||
      (pricel[currentTrough] > pricel[low+4])||
      (pricel[currentTrough] > pricel[low+5]) ||
      (pricel[currentTrough] > pricel[low+6])  ||
      (pricel[currentTrough] > pricel[low+7])||
      (pricel[currentTrough] > pricel[low+8])||
      (pricel[currentTrough] > pricel[low+9])||
      (pricel[currentTrough] > pricel[low+10])||
      (pricel[currentTrough] > pricel[low+11])||
      (pricel[currentTrough] > pricel[low+12])||
      (pricel[currentTrough] > pricel[low+13])||
      (pricel[currentTrough] > pricel[low+14])||
      (pricel[currentTrough] > pricel[low+15])
      )
      )       
      {
       bullishDivergence[currentTrough] = Buf1[currentTrough] - 
                                          arrowsDisplacement;
       //----
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentTrough], Time[lastTrough], 
                              pricel[currentTrough], 
                              pricel[lastTrough], Green, STYLE_DOT);
       //----
       if(drawIndicatorTrendLines == true)                            
           DrawIndicatorTrendLine(Time[currentTrough], 
                                  Time[lastTrough], 
                                  Buf1[currentTrough],
                                  Buf1[lastTrough], 
                                  Green, STYLE_DOT);
       //----
       if(displayAlert == true)
           DisplayAlert("   ", currentTrough);   
     }      
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CatchBearishDivergence(int shift)
  {
   if(IsIndicatorPeak(shift) == false)
       return;
   int currentPeak = shift;
   int peak=GetIndicatorLastPeak(shift, peak);
   int lastPeak = GetIndicatorLastPeak(shift, peak);
          
if( 
     //(priceh[currentPeak] >= priceh[currentPeak+1])&&
     (
      (Buf1[currentPeak] < Buf1[lastPeak] )||
      (Buf1[currentPeak] < Buf1[peak+2] ) ||
      (Buf1[currentPeak] < Buf1[peak+3] ) ||
      (Buf1[currentPeak] < Buf1[peak+4] ) ||
      (Buf1[currentPeak] < Buf1[peak+5] ) ||
      (Buf1[currentPeak] < Buf1[peak+6] ) ||
      (Buf1[currentPeak] < Buf1[peak+7] ) ||
      (Buf1[currentPeak] < Buf1[peak+8] ) ||
      (Buf1[currentPeak] < Buf1[peak+9] ) ||
      (Buf1[currentPeak] < Buf1[peak+10] )
      //(cci[currentPeak] < cci[peak+11] )||
      //(cci[currentPeak] < cci[peak+12] )||
      //(cci[currentPeak] < cci[peak+13] )||
      //(cci[currentPeak] < cci[peak+14] )||
      //(cci[currentPeak] < cci[peak+15] )     
      )
      &&
      (
      (priceh[currentPeak] > priceh[lastPeak])||
      (priceh[currentPeak] > priceh[peak+2])||
      (priceh[currentPeak] > priceh[peak+3])||
      (priceh[currentPeak] > priceh[peak+4])||
      (priceh[currentPeak] > priceh[peak+5])||
      (priceh[currentPeak] > priceh[peak+6])||
      (priceh[currentPeak] > priceh[peak+7])||
      (priceh[currentPeak] > priceh[peak+8])||
      (priceh[currentPeak] > priceh[peak+9])||
      (priceh[currentPeak] > priceh[peak+10])||
      (priceh[currentPeak] > priceh[peak+11])||
      (priceh[currentPeak] > priceh[peak+12])||
      (priceh[currentPeak] > priceh[peak+13])||
      (priceh[currentPeak] > priceh[peak+14])||
      (priceh[currentPeak] > priceh[peak+15])      
      )
      )
      
      {
       bearishDivergence[currentPeak] = Buf1[currentPeak] + 
                                        arrowsDisplacement;
      
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentPeak], Time[lastPeak], 
                              priceh[currentPeak], 
                              priceh[lastPeak], Red, STYLE_SOLID);
                            
       if(drawIndicatorTrendLines == true)
           DrawIndicatorTrendLine(Time[currentPeak], Time[lastPeak], 
                                  Buf1[currentPeak],
                                  Buf1[lastPeak], Red, STYLE_SOLID);

       if(displayAlert == true)
           DisplayAlert("  ",currentPeak );  
     }
  if( 
     //(priceh[currentPeak] >= priceh[currentPeak+1])&&
     (
      (Buf1[currentPeak] > Buf1[lastPeak] )||
      (Buf1[currentPeak] > Buf1[peak+2] ) ||
      (Buf1[currentPeak] > Buf1[peak+3] ) ||
      (Buf1[currentPeak] > Buf1[peak+4] ) ||
      (Buf1[currentPeak] > Buf1[peak+5] ) ||
      (Buf1[currentPeak] < Buf1[peak+6] ) ||
      (Buf1[currentPeak] > Buf1[peak+7] ) ||
      (Buf1[currentPeak] > Buf1[peak+8] ) ||
      (Buf1[currentPeak] > Buf1[peak+9] ) ||
      (Buf1[currentPeak] > Buf1[peak+10] )
      //(cci[currentPeak] > cci[peak+11] )||
      //(cci[currentPeak] > cci[peak+12] )||
      //(cci[currentPeak] > cci[peak+13] )||
      //(cci[currentPeak] > cci[peak+14] ) ||
      //(cci[currentPeak] > cci[peak+15] )     
      )&&
      (
      (priceh[currentPeak] < priceh[lastPeak])||
      (priceh[currentPeak] < priceh[peak+2])||
      (priceh[currentPeak] < priceh[peak+3])||
      (priceh[currentPeak] < priceh[peak+4])||
      (priceh[currentPeak] < priceh[peak+5])||
      (priceh[currentPeak] < priceh[peak+6])||
      (priceh[currentPeak] < priceh[peak+7])||
      (priceh[currentPeak] < priceh[peak+8])||
      (priceh[currentPeak] < priceh[peak+9])||
      (priceh[currentPeak] < priceh[peak+10]) ||
      (priceh[currentPeak] < priceh[peak+11]) ||
      (priceh[currentPeak] < priceh[peak+12]) ||
      (priceh[currentPeak] < priceh[peak+13])  ||
      (priceh[currentPeak] < priceh[peak+14])  ||
      (priceh[currentPeak] < priceh[peak+15])    
      )
      )
    
     {
       bearishDivergence[currentPeak] = Buf1[currentPeak] + 
                                        arrowsDisplacement;
       //----
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentPeak], Time[lastPeak], 
                              priceh[currentPeak], 
                              priceh[lastPeak], Red, STYLE_DOT);
       //----
       if(drawIndicatorTrendLines == true)
           DrawIndicatorTrendLine(Time[currentPeak], Time[lastPeak], 
                                  Buf1[currentPeak],
                                  Buf1[lastPeak], Red, STYLE_DOT);
       //----
       if(displayAlert == true)
           DisplayAlert("   ", currentPeak);   
     }   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsIndicatorPeak(int shift)
  {
   if(Buf1[shift] >= Buf1[shift+1] && 
   //cci[shift] >= cci[shift+2] && 
      Buf1[shift] >= Buf1[shift-1])
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsIndicatorTrough(int shift)
  {
   if(Buf1[shift] <= Buf1[shift+1] && 
   //cci[shift] <= cci[shift+2] && 
      Buf1[shift] <= Buf1[shift-1])
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndicatorLastPeak(int shift, int peak)
  {
   //for(int i = shift + 5; i < Bars; i++)
     //{
       //if(signal[i] >= signal[i+1] && 
       //signal[i] >= signal[i+2] &&
          //signal[i] >= signal[i-1] 
          //&& signal[i] >= signal[i-2]
          //)
         //{
           for(int j = shift; j < Bars; j++)
             {
             previoushighbuffer[j]=previoushighbuffer[j+1];
             peak=Buf1[j];
               if(Buf1[j] >= Buf1[j+1] && 
               //cci[j] >= cci[j+2] &&
                  Buf1[j] >= Buf1[j-1] 
               //&& cci[j] >= cci[j-2]
                  )
                   return(j);
                   previoushighbuffer[j]=peak;
                }
                //}
     //}
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndicatorLastTrough(int shift, int low)
  {
    //for(int i = shift + 5; i < Bars; i++)
      //{
        //if(signal[i] <= signal[i+1] && 
        //signal[i] <= signal[i+2] &&
           //signal[i] <= signal[i-1] 
           //&& signal[i] <= signal[i-2]
           //)
          //{
            for (int j = shift; j < Bars; j++)
              {
              previouslowbuffer[j]=previouslowbuffer[j+1];
              low=Buf1[j];
                if(Buf1[j] <= Buf1[j+1] && 
                //cci[j] <= cci[j+2] &&
                   Buf1[j] <= Buf1[j-1] 
                   //&& cci[j] <= cci[j-2]
                   )
                    return(j);
                    previouslowbuffer[j]=low;
              }
              //}
              //}
             return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DisplayAlert(string message, int shift)
  {
   if(shift <= 2 && Time[shift] != lastAlertTime)
     {
       lastAlertTime = Time[shift];
       Alert(message);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawPriceTrendLine(datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, double style)
  {
   string label = "prav div cci on array" + DoubleToStr(x1, 0);
   ObjectDelete(label);
   ObjectCreate(label, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(label, OBJPROP_RAY, 0);
   ObjectSet(label, OBJPROP_COLOR, lineColor);
   ObjectSet(label, OBJPROP_STYLE, style);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawIndicatorTrendLine(datetime x1, datetime x2, double y1, 
                            double y2, color lineColor, double style)
  {
   int indicatorWindow = WindowFind(indicatorName);
   if(indicatorWindow < 0)
       return;
   string label = "DivergenceLine" + DoubleToStr(x1, 0);
   ObjectDelete(label);
   ObjectCreate(label, OBJ_TREND, indicatorWindow, x1, y1, x2, y2, 
                0, 0);
   ObjectSet(label, OBJPROP_RAY, 0);
   ObjectSet(label, OBJPROP_COLOR, lineColor);
   ObjectSet(label, OBJPROP_STYLE, style);
  }
//+------------------------------------------------------------------+
 return(0);
  